From 9330ef9cb42d3adf02edfb3aad8e2af562bd421b Mon Sep 17 00:00:00 2001
From: Daan De Meyer <daan.j.demeyer@gmail.com>
Date: Jan 20 2022 16:52:29 +0000
Subject: [PATCH 12/15] journal: Add support for not indexing specific fields in compact mode


Entry arrays remain one of the big contributors to journal
disk usage (even after introducing 32-bit offsets). To
improve the situation, let's add an environment variable
$SYSTEMD_JOURNAL_NON_INDEXED_FIELDS that allows configuring
which fields should not be indexed.

Data object of fields that are not indexed simply don't have
any entry offsets added to their entry arrays. This has the
effect that when used as matches, these data objects don't
return any entry matches at all.

Before:

OBJECT TYPE	 ENTRIES SIZE
Unused           0       0B
Data             1022925 95.3M
Field            2808    151.3K
Entry            3499976 667.7M
Data Hash Table  13      46.2M
Field Hash Table 13      67.8K
Entry Array	 492907  576.7M
Tag              0       0B
Trie Node        1758648 67.0M
Trie Hash Table  13      69.3M
Total            6777303 1.4G

After:

SYSTEMD_JOURNAL_NON_INDEXED_FIELDS="_CAP_EFFECTIVE _PID _UID _GID _SELINUX_CONTEXT _SOURCE_REALTIME_TIMESTAMP _MACHINE_ID _HOSTNAME _STREAM_ID _LINE_BREAK SYSLOG_FACILITY SYSLOG_IDENTIFIER _COMM _CMDLINE _EXE _SYSTEMD_INVOCATION_ID"

OBJECT TYPE      ENTRIES SIZE
Unused           0       0B
Data             987596  92.5M
Field            2127    114.8K
Entry            3500464 667.8M
Data Hash Table  9       32.0M
Field Hash Table 9       46.9K
Entry Array      241932  200.3M
Tag              0       0B
Trie Node        1752229 66.8M
Trie Hash Table  9       47.9M
Total            6484375 1.0G

---

diff --git a/src/libsystemd/sd-journal/journal-def.h b/src/libsystemd/sd-journal/journal-def.h
index d2bbb3c..eef3f46 100644
--- a/src/libsystemd/sd-journal/journal-def.h
+++ b/src/libsystemd/sd-journal/journal-def.h
@@ -52,6 +52,7 @@ enum {
         OBJECT_COMPRESSED_ZSTD  = 1 << 2,
         OBJECT_COMPRESSION_MASK = (OBJECT_COMPRESSED_XZ | OBJECT_COMPRESSED_LZ4 | OBJECT_COMPRESSED_ZSTD),
         FIELD_UNIQUE            = 1 << 3,
+        FIELD_INDEXED           = 1 << 4,
         _OBJECT_COMPRESSED_MAX  = OBJECT_COMPRESSION_MASK,
 };
 
@@ -101,6 +102,7 @@ typedef struct {
         uint64_t hash;
         /* The hash used to calculate the Entry object's XOR hash field. */
         uint64_t xor_hash;
+        bool indexed;
 } EntryItemEx;
 
 #define EntryObject__contents {                \
diff --git a/src/libsystemd/sd-journal/journal-file.c b/src/libsystemd/sd-journal/journal-file.c
index bb7e942..3a8d541 100644
--- a/src/libsystemd/sd-journal/journal-file.c
+++ b/src/libsystemd/sd-journal/journal-file.c
@@ -1635,7 +1635,7 @@ static int journal_file_append_field(
         if (ret_offset)
                 *ret_offset = p;
 
-        return 0;
+        return 1;
 }
 
 static int maybe_compress_payload(JournalFile *f, uint8_t *dst, const uint8_t *src, size_t size, size_t *rsize) {
@@ -2441,6 +2441,9 @@ static int journal_file_link_entry(
 
         /* Link up the items */
         for (uint64_t i = 0; i < n_items; i++) {
+                if (!items[i].indexed)
+                        continue;
+
                 r = journal_file_link_entry_item(f, o, offset, items[i].object_offset);
                 if (r < 0)
                         return r;
@@ -2679,12 +2682,21 @@ static int journal_file_append_field_from_data(
                 Object **ret,
                 uint64_t *ret_offset) {
         const void *eq;
+        int r;
 
         eq = memchr(data, '=', size);
         if (!eq)
                 return -EINVAL;
 
-        return journal_file_append_field(f, data, (uint8_t*) eq - (uint8_t*) data, ret, ret_offset);
+        r = journal_file_append_field(f, data, (uint8_t*) eq - (uint8_t*) data, ret, ret_offset);
+        if (r < 0)
+                return r;
+
+        /* In compact mode, only index newly added fields. */
+        if (JOURNAL_HEADER_COMPACT(f->header) && r > 0)
+                (*ret)->object.flags |= FIELD_INDEXED;
+
+        return r;
 }
 
 int journal_file_append_entry(
@@ -2764,6 +2776,8 @@ int journal_file_append_entry(
                         .xor_hash = JOURNAL_HEADER_KEYED_HASH(f->header) ?
                                 jenkins_hash64(iovec[i].iov_base, iovec[i].iov_len) :
                                 le64toh(o->data.hash),
+                        .indexed = !JOURNAL_HEADER_COMPACT(f->header) ||
+                                FLAGS_SET(fo->object.flags, FIELD_INDEXED),
                 };
         }
 
@@ -4004,6 +4018,43 @@ static int add_unique_fields(JournalFile *f) {
         return 0;
 }
 
+static int add_non_indexed_fields(JournalFile *f) {
+        const char *e;
+        int r;
+
+        e = getenv("SYSTEMD_JOURNAL_NON_INDEXED_FIELDS");
+        if (!e)
+                return 0;
+
+        for (const char *p = e;;) {
+                _cleanup_free_ char *word = NULL;
+
+                r = extract_first_word(&p, &word, NULL, 0);
+                if (r == 0)
+                        return 0;
+                if (r == -ENOMEM)
+                        return log_oom();
+                if (r < 0) {
+                        log_debug_errno(r, "Failed to parse $SYSTEMD_JOURNALD_NON_INDEXED_FIELDS environment variable, ignoring: %m");
+                        return 0;
+                }
+
+                if (!journal_field_valid(word, strlen(word), true)) {
+                        log_debug("Invalid field name in $SYSTEMD_JOURNALD_NON_INDEXED_FIELDS environment variable, ignoring: %s", word);
+                        continue;
+                }
+
+                /* By default, all fields are created with the FIELD_INDEXED flag, indicating they should be
+                 * indexed. By creating the fields here but not setting the FIELD_INDEXED flag, we make sure
+                 * they aren't indexed. */
+                r = journal_file_append_field(f, word, strlen(word), NULL, NULL);
+                if (r < 0)
+                        return r;
+        }
+
+        return 0;
+}
+
 int journal_file_open(
                 int fd,
                 const char *fname,
@@ -4245,6 +4296,10 @@ int journal_file_open(
                         r = add_unique_fields(f);
                         if (r < 0)
                                 goto fail;
+
+                        r = add_non_indexed_fields(f);
+                        if (r < 0)
+                                goto fail;
                 }
 
 #if HAVE_GCRYPT
@@ -4440,6 +4495,8 @@ int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint6
                         .hash = le64toh(u->data.hash),
                         .xor_hash = JOURNAL_HEADER_KEYED_HASH(to->header) ? jenkins_hash64(data, l) :
                                                                             le64toh(u->data.hash),
+                        .indexed = !JOURNAL_HEADER_COMPACT(to->header) ||
+                                FLAGS_SET(fo->object.flags, FIELD_INDEXED),
                 };
         }
 
diff --git a/src/libsystemd/sd-journal/journal-verify.c b/src/libsystemd/sd-journal/journal-verify.c
index c790345..d286f98 100644
--- a/src/libsystemd/sd-journal/journal-verify.c
+++ b/src/libsystemd/sd-journal/journal-verify.c
@@ -161,7 +161,7 @@ static int journal_file_object_verify(JournalFile *f, uint64_t offset, Object *o
                 uint64_t h1, h2;
                 int r;
 
-                if (le64toh(o->data.entry_offset) == 0)
+                if (!JOURNAL_HEADER_COMPACT(f->header) && le64toh(o->data.entry_offset) == 0)
                         warning(offset, "Unused data (entry_offset==0)");
 
                 if ((le64toh(o->data.entry_offset) == 0) ^ (le64toh(o->data.n_entries) == 0)) {

